import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ghost here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ghost  extends Mover
{
    private boolean isOut = false;
    public boolean canMove = true;
    private String direction = null;
    private String color = null;
    private int MAX_DEAD_TIME = 75;
    private int frameCount = 0;
    public boolean isDead = false;
    private GreenfootImage ghostWhite = new GreenfootImage("ghost_w.png");
    private GreenfootImage ghostBlue = new GreenfootImage("ghost_b.png");
    private GreenfootImage ghostCyan = new GreenfootImage("ghost_c.png");
    private GreenfootImage ghostPink = new GreenfootImage("ghost_p.png");
    private GreenfootImage ghostRed = new GreenfootImage("ghost_r.png");
    private GreenfootImage ghostYellow = new GreenfootImage("ghost_y.png");
    private GreenfootImage ghostEyes = new GreenfootImage("ghost_eyes.png");
    public Ghost(String ghostColor) {
        color = ghostColor;
        setColor();
    }
    
    /**
     * Act - do whatever the Ghost wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(isOut && canMove) {
            go();
            
            Pacworld world = (Pacworld) getWorld();
            if(!isDead) {
                if(world.canEatGhosts) {
                    if(world.MAX_GHOST_TIME - world.ghostTimer <= 30 && world.ghostTimer % 5 == 0) {
                        setImage(ghostWhite);
                    } else {
                        setImage(ghostBlue);
                    }
                } else {
                    setColor();
                }
            } else {
                if(frameCount >= MAX_DEAD_TIME) {
                    isDead = false;
                    setColor();
                    frameCount = -1;
                }
                frameCount++;
            }
            
            if(isOn(Pacman.class) && !world.canEatGhosts && !isDead) {
                eat(Pacman.class);
            }
        
            if(atWorldEdge()) {
                if(direction == "right") {
                    setLocation(0, getY());
                } else if (direction == "left") {
                    setLocation(getWorld().getWidth(), getY());
                }
            }
            
        } else if(!isOut && canMove) {
            int x = getX();
            int y = getY();
            if(x == 47 && y == 57) {
                // red
                setLocation(47, 56);
            } else if (x == 47 && y == 56) {
                setLocation(47, 55);
            } else if (x == 47 && y == 55) {
                setLocation(47, 54);
            } else if (x == 47 && y == 54) {
                setLocation(47, 53);
            } else if (x == 47 && y == 53) {
                setLocation(47, 52);
                isOut = true;
                frameCount = -1;
            } else if (x == 47 && y == 62) {
                // pink
                setLocation(47, 61);
            } else if (x == 47 && y == 61) {
                setLocation(47, 60);
            } else if (x == 47 && y == 60) {
                setLocation(47, 59);
            } else if (x == 47 && y == 59) {
                setLocation(47, 58);
            } else if (x == 47 && y == 58) {
                setLocation(47, 57);
            } else if (x == 42 && y == 62) {
                // cyan
                setLocation(43, 62);
            } else if (x == 43 && y == 62) {
                setLocation(44, 62);
            } else if (x == 44 && y == 62) {
                setLocation(45, 62);
            } else if (x == 45 && y == 62) {
                setLocation(46, 62);
            } else if (x == 46 && y == 62) {
                setLocation(47, 62);
            } else if (x == 52 && y == 62 && frameCount == 5) {
                // yellow
                setLocation(51, 62);
            } else if (x == 51 && y == 62) {
                setLocation(50, 62);
            } else if (x == 50 && y == 62) {
                setLocation(49, 62);
            } else if (x == 49 && y == 62) {
                setLocation(48, 62);
            } else if (x == 48 && y == 62) {
                setLocation(47, 62);
            }
            frameCount++;
        }
    }
    
    public void go() {
        if(direction != null && canMove(direction)) {
            move(direction);
        } else {
            int randNum = Greenfoot.getRandomNumber(4);
            direction = setDir(randNum);
            go();
        }
    }
    
    public String setDir(int randNum) {
        String direction = "";
        if (randNum == 0) {
            direction = "left";
        } else if (randNum == 1) {
            direction = "right";
        } else if (randNum == 2) {
            direction = "up";
        } else {
            direction = "down";
        }
        return direction;
    }
    
    public void setColor() {
        if(color == "cyan") {
            setImage(ghostCyan);
        } else if (color == "pink") {
            setImage(ghostPink);
        } else if (color == "red") {
            setImage(ghostRed);
        } else if (color == "yellow") {
            setImage(ghostYellow);
        }
    }
    
    public void move(String direction) {
        if(direction == "right") {
            setLocation(getX()+1,getY());
        }
        if(direction == "left") {
            setLocation(getX()-1,getY());
        }
        if(direction == "up") {
            setLocation(getX(),getY()-1);
        }
        if(direction == "down") {
            setLocation(getX(),getY()+1);
        }
    }
    
    public void die() {
        setImage(ghostEyes);
        isDead = true;
    }
}
