import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * Write a description of class Pacman here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Pacman extends Mover
{
    public static GreenfootSound sound = new GreenfootSound("wakka.wav");
    private static GreenfootImage pacR1 = new GreenfootImage("pacman_r.png");
    private static GreenfootImage pacR2 = new GreenfootImage("pacman_r_1.png");
    private static GreenfootImage pacR3 = new GreenfootImage("pacman_r_2.png");
    private static GreenfootImage[] rightImg = new GreenfootImage[]{pacR1, pacR1, pacR2, pacR2, pacR3, pacR3};
    private static GreenfootImage pacL1 = new GreenfootImage("pacman_l.png");
    private static GreenfootImage pacL2 = new GreenfootImage("pacman_l_1.png");
    private static GreenfootImage pacL3 = new GreenfootImage("pacman_l_2.png");
    private static GreenfootImage[] leftImg = new GreenfootImage[]{pacL1, pacL1, pacL2, pacL2, pacL3, pacL3};
    private static GreenfootImage pacU1 = new GreenfootImage("pacman_u.png");
    private static GreenfootImage pacU2 = new GreenfootImage("pacman_u_1.png");
    private static GreenfootImage pacU3 = new GreenfootImage("pacman_u_2.png");
    private static GreenfootImage[] upImg = new GreenfootImage[]{pacU1, pacU1, pacU2, pacU2, pacU3, pacU3};
    private static GreenfootImage pacD1 = new GreenfootImage("pacman_d.png");
    private static GreenfootImage pacD2 = new GreenfootImage("pacman_d_1.png");
    private static GreenfootImage pacD3 = new GreenfootImage("pacman_d_2.png");
    private static GreenfootImage[] downImg = new GreenfootImage[]{pacD1, pacD1, pacD2, pacD2, pacD3, pacD3};
    private static GreenfootImage pacFull = new GreenfootImage("pacman_full.png");
    private GreenfootImage curImg = pacFull;
    public String lastPressed = null;
    private boolean isOpening = false;
    public boolean canMove = true;
    private int frame = 0;
    /**
     * Act - do whatever the Pacman wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(canMove) {
        String direction = getDirection();
        if(canMove(direction)) {
            lastPressed = direction;
            move(direction);
            wakka();
        } else if (canMove(lastPressed)) {
            move(lastPressed);
            wakka();
        } else {
            sound.stop();
        }
        
        if(isOn(Pacdot.class)) {
            eat(Pacdot.class);
        }
        
        if(isOn(Powerpellet.class)) {
            eat(Powerpellet.class);
        }
        
        if(isOn(Cherry.class)) {
            eat(Cherry.class);
        }
        
        Pacworld world = (Pacworld) getWorld();
        
        if(world.ghostTimer > world.MAX_GHOST_TIME) {
            world.canEatGhosts = false;
            world.ghostTimer = 0;
        }
        
        if(world.canEatGhosts) {
            if(isOn(Ghost.class)) {
                eat(Ghost.class);
            }
            world.ghostTimer++;
        }
        
        if(atWorldEdge()) {
            if(direction == "right") {
                setLocation(0, getY());
            } else if (direction == "left") {
                setLocation(getWorld().getWidth(), getY());
            }
        }
    } else {
        sound.stop();
    }
    }
    
    public void wakka() {
        if(getObjectsInRange(6, Pacdot.class).size() > 0) {
            sound.playLoop();
        } else {
            sound.stop();
        }
    }
    
    public void move(String direction) {
        
        if(direction == "right") {
            if(frame>=rightImg.length-1) isOpening = true;
            else if(frame == 0) isOpening = false;
            setImage(rightImg[frame]);
            if(isOpening) frame--;
            else frame++;
            setLocation(getX()+1,getY());
        }
        if(direction == "left") {
            if(frame>=leftImg.length-1) isOpening = true;
            else if(frame == 0) isOpening = false;
            setImage(leftImg[frame]);
            if(isOpening) frame--;
            else frame++;
            setLocation(getX()-1,getY());
        }
        if(direction == "up") {
            if(frame>=upImg.length-1) isOpening = true;
            else if(frame == 0) isOpening = false;
            setImage(upImg[frame]);
            if(isOpening) frame--;
            else frame++;
            setLocation(getX(),getY()-1);
        }
        if(direction == "down") {
            if(frame>=downImg.length-1) isOpening = true;
            else if(frame == 0) isOpening = false;
            setImage(downImg[frame]);
            if(isOpening) frame--;
            else frame++;
            setLocation(getX(),getY()+1);
        }
    }
    
    public String getDirection() {
        String direction = null;
        if(Greenfoot.isKeyDown("up")) direction = "up";
        if(Greenfoot.isKeyDown("down")) direction = "down";
        if(Greenfoot.isKeyDown("left")) direction = "left";
        if(Greenfoot.isKeyDown("right")) direction = "right";
        if(direction != null) {
            return direction;
        } else {
            return lastPressed;
        }
    }
}
