import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.Collections;

/**
 * Write a description of class Pacworld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Pacworld  extends World
{
    private Counter currentScore;
    private Counter currentLives;
    private Counter ready = new Counter("Ready!");
    private Pacman pacman = new Pacman();
    private Cherry cherry = new Cherry();
    public boolean canEatGhosts = false;
    private int frameCount = 0;
    private boolean isEnding = false;
    private boolean isDieing = false;
    public int ghostTimer = 0;
    public int MAX_GHOST_TIME = 150;
    public int LEVEL_LOAD_TIME = 50;
    public int curLevel = 0;
    public int numLives = 3;
    private boolean levelLoading = false;
    private GreenfootSound siren = new GreenfootSound("siren.wav");
    private GreenfootSound blue = new GreenfootSound("blue.wav");
    private GreenfootSound eyes = new GreenfootSound("eyes.wav");
    /**
     * Constructor for objects of class Pacworld.
     * 
     */
    public Pacworld()
    {    
        super(5*19, 5*25, 4);
        Greenfoot.setSpeed(43);
        setPaintOrder(Counter.class,Wall.class,Pacman.class,Ghost.class,Cherry.class);
        // Add texts
        currentScore = new Counter();
        addObject(currentScore, 87, 7);
        Counter textScore = new Counter("Score:");
        addObject(textScore, 87, 2);
        
        currentLives = new Counter(numLives, false);
        addObject(currentLives, 5, 7);
        Counter textLives = new Counter("Lives:");
        addObject(textLives, 5, 2);
        
        loadLevel(1);
        currentLives.decCount(1);
        numLives--;
        
        GreenfootSound start = new GreenfootSound("start.wav");
        start.play();
    }
    
    public void act() {
        if(levelLoading && frameCount < LEVEL_LOAD_TIME) {
            List ghosts = getObjects(Ghost.class);
            for(int i = 0;i<ghosts.size();i++) {
                Ghost ghost = (Ghost) ghosts.get(i);
                ghost.canMove = false;
            }
            pacman.canMove = false;
            addObject(ready, 47, 72);
            frameCount++;
        } else if (levelLoading && frameCount >= LEVEL_LOAD_TIME) {
            frameCount = 0;
            pacman.lastPressed = "left";
            pacman.canMove = true;
            List ghosts = getObjects(Ghost.class);
            for(int i = 0;i<ghosts.size();i++) {
                Ghost ghost = (Ghost) ghosts.get(i);
                ghost.canMove = true;
            }
            removeObject(ready);
            levelLoading = false;
        }
        if(isEnding) endGame();
        if(isDieing) decLives();
        if(currentScore.totalCount >= 7000 && curLevel == 1) loadLevel(2);
        if(areDeadGhosts() && !isEnding && pacman.canMove) {
            eyes.playLoop();
            blue.stop();
            siren.stop();
        } else if(canEatGhosts && !isEnding && pacman.canMove) {
            blue.playLoop();
            siren.stop();
            eyes.stop();
        } else if(!isEnding && pacman.canMove) {
            siren.playLoop();
            blue.stop();
            eyes.stop();
        } else if(!pacman.canMove) {
            siren.stop();
            blue.stop();
            eyes.stop();
        }
        if(getObjects(Pacdot.class).size() < 1 && getObjects(Powerpellet.class).size() <1) endGame();
        if(Greenfoot.getRandomNumber(500) == 200 && !isEnding && pacman.canMove) {
            cherry.engage();
        }
    }
    
    public void stopped() {
        siren.stop();
        blue.stop();
        eyes.stop();
        pacman.sound.stop();
    }
    
    public Counter getCounter() {
        return currentScore;
    }
    
    public Counter getLives() {
        return currentLives;
    }
    
    public void loadLevel(int levelNum) {
        if(levelNum == 1) {
            int[] level = {
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,
            0,2,0,0,1,0,0,0,1,0,1,0,0,0,1,0,0,2,0,
            0,1,0,0,1,0,0,0,1,0,1,0,0,0,1,0,0,1,0,
            0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
            0,1,0,0,1,0,1,0,0,0,0,0,1,0,1,0,0,1,0,
            0,1,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,1,0,
            0,0,0,0,1,0,0,0,3,0,3,0,0,0,1,0,0,0,0,
            3,3,3,0,1,0,3,3,3,3,3,3,3,0,1,0,3,3,3,
            0,0,0,0,1,0,3,0,0,3,0,0,3,0,1,0,0,0,0,
            3,3,3,3,1,3,3,0,3,3,3,0,3,3,1,3,3,3,3,
            0,0,0,0,1,0,3,0,0,0,0,0,3,0,1,0,0,0,0,
            3,3,3,0,1,0,3,3,3,3,3,3,3,0,1,0,3,3,3,
            0,0,0,0,1,0,3,0,0,0,0,0,3,0,1,0,0,0,0,
            0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,
            0,1,0,0,1,0,0,0,1,0,1,0,0,0,1,0,0,1,0,
            0,2,1,0,1,1,1,1,1,3,1,1,1,1,1,0,1,2,0,
            0,0,1,0,1,0,1,0,0,0,0,0,1,0,1,0,1,0,0,
            0,1,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,1,0,
            0,1,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,1,0,
            0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        };
        newLevel(level);
    } else if(levelNum == 2) {
            int[] level = {
            3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,
            3,3,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,3,3,
            3,3,0,1,1,0,1,0,0,1,0,0,1,0,1,1,0,3,3,
            0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,0,
            3,3,3,3,3,3,3,0,2,1,2,0,3,3,3,3,3,3,3,
            0,0,0,1,0,1,0,0,0,0,0,0,0,1,0,1,0,0,0,
            0,1,1,1,0,1,1,1,1,1,1,1,1,1,0,1,1,1,0,
            0,1,0,1,0,0,0,0,0,3,0,0,0,0,0,1,0,1,0,
            0,1,0,1,1,1,3,3,3,3,3,3,3,1,1,1,0,1,0,
            0,1,0,0,0,0,3,0,0,3,0,0,3,0,0,0,0,1,0,
            0,1,1,1,1,1,3,0,3,3,3,0,3,1,1,1,1,1,0,
            0,1,0,0,0,0,3,0,0,0,0,0,3,0,0,0,0,1,0,
            0,1,1,1,1,1,3,3,3,3,3,3,3,1,1,1,1,1,0,
            0,1,0,0,0,0,3,0,0,0,0,0,3,0,0,0,0,1,0,
            0,1,0,1,1,1,1,1,1,0,1,1,1,1,1,1,0,1,0,
            0,1,1,1,0,1,0,0,1,0,1,0,0,1,0,1,1,1,0,
            0,0,0,1,0,1,1,1,1,3,1,1,1,1,0,1,0,0,0,
            3,3,3,3,0,1,0,0,0,0,0,0,0,1,0,3,3,3,3,
            0,0,0,1,0,1,1,1,2,0,2,1,1,1,0,1,0,0,0,
            3,3,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,3,3,
            3,3,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,3,3,
            3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3
        };
        newLevel(level);
    }
    curLevel = levelNum;
    }
    
    public void newLevel(int array[]) {
        levelLoading = true;
        canEatGhosts = false;
        List ghosts = getObjects(Ghost.class);
        for(int i = 0;i<ghosts.size();i++) {
            Ghost ghost = (Ghost) ghosts.get(i);
            ghost.isDead = false;
        }
        removeObjects(getObjects(Wall.class));
        removeObjects(getObjects(Powerpellet.class));
        removeObjects(getObjects(Pacdot.class));
        removeObjects(getObjects(Ghost.class));
        removeObjects(getObjects(Pacman.class));
        removeObjects(getObjects(Cherry.class));
        
        // Add characters & gate
        addObject(pacman, 47, 92);
        Gate gate= new Gate();
        addObject(gate, 47, 57);
        Ghost ghostC= new Ghost("cyan");
        addObject(ghostC, 42, 62);
        Ghost ghostP= new Ghost("pink");
        addObject(ghostP, 47, 62);
        Ghost ghostY= new Ghost("yellow");
        addObject(ghostY, 52, 62);
        Ghost ghostR= new Ghost("red");
        addObject(ghostR, 47, 57);
        addObject(cherry, 82, 122);
        
        int i = 0;
        
        for (int y = 4/2+10; y<24*5; y+=5) {
            for (int x = 4/2; x<19*5; x+=5) {
                int type = array[i];
                
                if(type == 0) {
                    addObject(new Wall(), x, y);
                } else if (type == 1) {
                    addObject(new Pacdot(), x, y);
                } else if (type == 2) {
                    addObject(new Powerpellet(), x, y);
                } else if (type == 3) {
                    // Empty space or ghost/pacman
                }
                
                if (i < array.length-1) i++;
            }
        }
        numLives++;
        currentLives.bumpCount(1);
    }
    
    public boolean areDeadGhosts() {
        List ghosts = getObjects(Ghost.class);
        for(int i = 0;i<ghosts.size();i++) {
            Ghost ghost = (Ghost) ghosts.get(i);
            if(ghost.isDead) return true;
        }
        return false;
    }
    
    public void endGame() {
        blue.stop();
        siren.stop();
        eyes.stop();
        if(frameCount == 0) {    
            isEnding = true;
            Counter gameOverText = new Counter("GAME OVER");
            addObject(gameOverText, 47, 72);
            List ghosts = getObjects(Ghost.class);
            for(int i = 0;i<ghosts.size();i++) {
                Ghost ghost = (Ghost) ghosts.get(i);
                ghost.canMove = false;
            }
            pacman.canMove = false;
            GreenfootSound dieSound = new GreenfootSound("die.wav");
            dieSound.play();
            numLives--;
            currentLives.decCount(1);
            pacman.setImage("pacman_c.png");
        } else if(frameCount == 2) {
            pacman.setImage("pacman_c_1.png");
        } else if(frameCount == 4) {
            pacman.setImage("pacman_c_2.png");
        } else if(frameCount == 6) {
            pacman.setImage("pacman_c_3.png");
        } else if(frameCount == 8) {
            pacman.setImage("pacman_c_4.png");
        } else if(frameCount == 10) {
            pacman.setImage("pacman_c_5.png");
        } else if(frameCount == 12) {
            pacman.setImage("pacman_c_6.png");
        } else if(frameCount == 14) {
            removeObject(pacman);
        }
        frameCount++;
    }
    
    public void decLives() {
        if(frameCount == 0) {    
            numLives--;
            isDieing = true;
            List ghosts = getObjects(Ghost.class);
            for(int i = 0;i<ghosts.size();i++) {
                Ghost ghost = (Ghost) ghosts.get(i);
                ghost.canMove = false;
            }
            pacman.canMove = false;
            GreenfootSound dieSound = new GreenfootSound("die.wav");
            dieSound.play();
            currentLives.decCount(1);
            pacman.setImage("pacman_c.png");
        } else if(frameCount == 2) {
            pacman.setImage("pacman_c_1.png");
        } else if(frameCount == 4) {
            pacman.setImage("pacman_c_2.png");
        } else if(frameCount == 6) {
            pacman.setImage("pacman_c_3.png");
        } else if(frameCount == 8) {
            pacman.setImage("pacman_c_4.png");
        } else if(frameCount == 10) {
            pacman.setImage("pacman_c_5.png");
        } else if(frameCount == 12) {
            pacman.setImage("pacman_c_6.png");
        } else if(frameCount == 14) {
            removeObject(pacman);
            pacman.setImage("pacman_full.png");
            frameCount = -1;
            addObject(pacman, 47, 92);
            addObject(ready, 47, 72);
            isDieing = false;
            removeObjects(getObjects(Ghost.class));
            List ghosts = getObjects(Ghost.class);
            for(int i = 0;i<ghosts.size();i++) {
                Ghost ghost = (Ghost) ghosts.get(i);
                ghost.canMove = true;
            }
            Ghost ghostC= new Ghost("cyan");
            addObject(ghostC, 42, 62);
            Ghost ghostP= new Ghost("pink");
            addObject(ghostP, 47, 62);
            Ghost ghostY= new Ghost("yellow");
            addObject(ghostY, 52, 62);
            Ghost ghostR= new Ghost("red");
            addObject(ghostR, 47, 57);
            Greenfoot.delay(LEVEL_LOAD_TIME);
            removeObject(ready);
            pacman.lastPressed = "left";
            pacman.canMove = true;
        }
        frameCount++;
    }
}